这道题要求我们求出图中的给定的两个节点(一个起点一个终点,但这是无向图)之间所有“路径中最大权值”的最小值,这无疑是动态规划。

我开始时想到根据起点和终点用动态规划直接求结果,但最终由于题中S过大,会超时。

超时的代码如下:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <string>
#include <algorithm> using namespace std;
const int MAX = 1000000;
int w[100][100];
int vis[100];
int C,S,Q; int f(int s, int t)
{
vis[t]=1;
int minb=MAX,tmp;
for(int i=0; i<C; i++) if(!vis[i] && w[t][i]!=-1)
{
if(i==s) { minb=w[t][i]; continue;}
tmp = f(s,i);
tmp = (tmp > w[t][i] ? tmp : w[t][i]);
minb = (minb < tmp ? minb : tmp);
}
vis[t]=0;
return minb;
}
int main()
{
int c1,c2;
int Case=0;
while(cin >> C >> S >> Q && C!=0)
{
memset(w,-1,sizeof(w));
for(int i=0; i<S; i++) {
cin >> c1 >> c2; cin >> w[c1-1][c2-1]; w[c2-1][c1-1]=w[c1-1][c2-1];
}
if(Case) cout << endl;
cout << "Case #" << ++Case << endl; while(Q--)
{
memset(vis,0,sizeof(vis));
cin >> c1 >> c2;
int ans = f(c1-1,c2-1);
if(ans==MAX) cout << "no path\n";
else cout << ans << endl;
}
}
return 0;
}

被判超时后想到,由于S过大,即要求的起始节点对过多,最好一次性全部求出来。在uva的board中看到别人有使用Floyd_WarShall算法的,受到启发,就自己思考了一下。

Floyd_WarShall算法本身肯定无法完成这题的解答,但只要改写其更新节点值的式子就可以解决这道题。我将更改后的算法命名为Floyd_WarShallEx,代码如下:

void Floyd_WarShallEx()
{
for(int k=0; k<C; k++)
{
for(int i=0; i<C; i++)
{
for(int j=0; j<C; j++)
{
w[i][j] = (w[i][j] < (w[i][k]>w[k][j]?w[i][k]:w[k][j]) ? w[i][j] : (w[i][k]>w[k][j]?w[i][k]:w[k][j]));
}
}
}
}

其中C为图中节点数,w[i][j]表示节点对i,j之间题目所要求的结果。通过下式更新w[i][j]的值:

w[i][j] = (w[i][j] < (w[i][k]>w[k][j]?w[i][k]:w[k][j]) ? w[i][j] : (w[i][k]>w[k][j]?w[i][k]:w[k][j]));

至此,调用Floyd_WarShallEx函数就可以完成所有节点对题目要求的结果的计算。

完整的解题代码如下:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <string>
#include <algorithm> using namespace std;
const int MAX = 1000000;
int w[100][100];
int vis[100];
int C,S,Q; void Floyd_WarShallEx()
{
for(int k=0; k<C; k++)
{
for(int i=0; i<C; i++)
{
for(int j=0; j<C; j++)
{
w[i][j] = (w[i][j] < (w[i][k]>w[k][j]?w[i][k]:w[k][j]) ? w[i][j] : (w[i][k]>w[k][j]?w[i][k]:w[k][j]));
}
}
}
} int main()
{
int c1,c2;
int Case=0;
while(cin >> C >> S >> Q && C!=0)
{
for(int i=0; i<C; i++)
for(int j=0; j<C; j++)
w[i][j]=MAX;
for(int i=0; i<S; i++) {
cin >> c1 >> c2; cin >> w[c1-1][c2-1]; w[c2-1][c1-1]=w[c1-1][c2-1];
}
Floyd_WarShallEx(); if(Case) cout << endl;
cout << "Case #" << ++Case << endl; while(Q--)
{
cin >> c1 >> c2;
if(w[c1-1][c2-1]==MAX) cout << "no path\n";
else cout << w[c1-1][c2-1] << endl;
}
}
return 0;
}

附上题目:

Consider yourself lucky! Consider yourself lucky to be still breathing and having fun participating in this contest. But we apprehend that many of your descendants may not have this luxury. For, as you know, we are the dwellers of one of the most polluted cities on earth. Pollution is everywhere, both in the environment and in society and our lack of consciousness is simply aggravating the situation.

However, for the time being, we will consider only one type of pollution ­- the sound pollution. The loudness or intensity level of sound is usually measured in decibels and sound having intensity level 130 decibels or higher is considered painful. The intensity level of normal conversation is 60­-65 decibels and that of heavy traffic is 70-­80 decibels.

Consider the following city map where the edges refer to streets and the nodes refer to crossings. The integer on each edge is the average intensity level of sound (in decibels) in the corresponding street.

To get from crossing A to crossing G you may follow the following path: A­C­F­G. In that case you must be capable of tolerating sound intensity as high as 140 decibels. For the paths A­B­E­G, A­B­D­G and A­C­F­D­G you must tolerate respectively 90, 120 and 80 decibels of sound intensity. There are other paths, too. However, it is clear that A­C­F­D­G is the most comfortable path since it does not demand you to tolerate more than 80 decibels.

In this problem, given a city map you are required to determine the minimum sound intensity level you must be able to tolerate in order to get from a given crossing to another.

Input

The input may contain multiple test cases.

The first line of each test case contains three integers ,  and where C indicates the number of crossings (crossings are numbered using distinct integers ranging from 1 to C), S represents the number of streets and Q is the number of queries.

Each of the next S lines contains three integers: c1, c2 and d indicating that the average sound intensity level on the street connecting the crossings c1 and c2 ( ) is d decibels.

Each of the next Q lines contains two integers c1 and c2 ( ) asking for the minimum sound intensity level you must be able to tolerate in order to get from crossing c1 to crossing c2.

The input will terminate with three zeros form C, S and Q.

Output

For each test case in the input first output the test case number (starting from 1) as shown in the sample output. Then for each query in the input print a line giving the minimum sound intensity level (in decibels) you must be able to tolerate in order to get from the first to the second crossing in the query. If there exists no path between them just print the line ``no path".

Print a blank line between two consecutive test cases.

Sample Input

7 9 3
1 2 50
1 3 60
2 4 120
2 5 90
3 6 50
4 6 80
4 7 70
5 7 40
6 7 140
1 7
2 6
6 2
7 6 3
1 2 50
1 3 60
2 4 120
3 6 50
4 6 80
5 7 40
7 5
1 7
2 4
0 0 0

Sample Output

Case #1
80
60
60 Case #2
40
no path
80

UVa 10048: Audiophobia的更多相关文章

  1. uva 10048 Audiophobia(最小生成树)

    题目链接:10048 - Audiophobia 题目大意:有n个城市,和m条街道,每条街道有一个噪音值,q次去问,从城市a到城市b,路径上分贝值的最大值最小为多少. 解题思路:与uva 10099的 ...

  2. UVA - 10048 Audiophobia (Floyd应用)

    题意:求出两点之间所有路径最大权值的最小值. 思路:转变一下Floyd的形式即可: 注意:注意初始化问题,还有UVA奇葩的输出形式. 代码如下: #include<iostream> #i ...

  3. UVa 10048 - Audiophobia(Floyd变形)

    链接: https://uva.onlinejudge.org/index.php?option=com_onlinejudge&Itemid=8&page=show_problem& ...

  4. UVa 10048 Audiophobia【Floyd】

    题意:给出一个c个点,s条边组成的无向图,求一点到另一点的路径上最大权值最小的路径,输出这个值 可以将这个 d[i][j]=min(d[i][j],d[i][k]+d[k][j]) 改成 d[i][j ...

  5. UVA 10048 Audiophobia 任意两点的路径上最大的边

    题目是要求任意给定两点的的路径上最大的边,最终输出这些最大边中最小的值,也就是求一条路径使得这条路径上最大的边在所有连通两点的路径中最短.根据Floyd—Warshall算法改造一下就行了.dp[i] ...

  6. UVA - 10048 Audiophobia Floyd

    思路:套用Floyd算法思想,d(i, j) = min(d(i,j), max(d(i,k), d(k,j)),就能很方便求得任意两点之间的最小噪音路径. AC代码 #include <cst ...

  7. UVA - 10048 Audiophobia(Floyd求路径上最大值的最小)

    题目&分析: 思路: Floyd变形(见上述紫书分析),根据题目要求对应的改变判断条件来解题. 代码: #include <bits/stdc++.h> #define inf 0 ...

  8. uva 10048 Audiophobia UVA - 10048

    题目简介 一个无向正权图,求任意两个节点之间的路径里最短的路径长度. 直接Floyd解决,就是注意要把Floyd的DP式子改一下成 G[i][j]=min(G[i][j],max(G[i][k],G[ ...

  9. UVa 10048 (Floyd变形) Audiophobia

    题意: 给一个带权无向图,和一些询问,每次询问两个点之间最大权的最小路径. 分析: 紫书上的题解是错误的,应该是把原算法中的加号变成max即可.但推理过程还是类似的,如果理解了Floyd算法的话,这个 ...

随机推荐

  1. [转] vim 正则表达式 很强大

    毋庸多言,在vim中正则表达式得到了十分广泛的应用. 最常用的 / 和 :s 命令中,正则表达式都是不可或缺的. 下面对vim中的正则表达式的一些难点进行说明. 关于magic vim中有个magic ...

  2. 关于apache下同IP多域名支持HTTPS和80跳转HTTPS的配置

    httpd-ssl的配置: Listen 443 NameVirtualHost *:443 AddType application/x-x509-ca-cert .crt AddType appli ...

  3. HDU 3572 最大流

    [题意]有n个任务,每个任务必须开始于第Si天之后(包括Si),结束于第Ei天之前(包括Ei),每个任务持续的时间为Pi,现在有m台机器,每台每天只能专注做其中一件任务,每个任务做的时间可以不连续.问 ...

  4. Asp.net中用户自定义控件 ascx的使用

    使用ascx目的就是为了提高某部分功能的重复利用,我简单通过源代码说一下对它的参数的输入和数出. 我们以省市区三级连动为例子. vs2005下ascx页面的代码: <table width=&q ...

  5. 关于slideup和slidedown 鼠标多次滑过累积的动画效果

    stop() 方法停止当前正在运行的动画 包括animation动画和slideup/slidedown动画 例如:鼠标经过一个元素时,执行一个slide动画,多次快速经过,不处理的话这个元素会保留累 ...

  6. 如何安装Oracle Database 11g数据库

    先选择你适合你的系统版本,32位系统的请选择32位的,64位系统可以使用32位也可以使用64位,建议采用64位的! 适用于 Microsoft Windows(32 位)的 Oracle Databa ...

  7. Swift - 38 - 枚举的基本语法

    //: Playground - noun: a place where people can play import UIKit // 创建一个枚举类型就相当于创建了一个新的数据类型, 所以首字母应 ...

  8. CIPAddressCtrl控件

    CIPAddressCtrl m_ipCtrl; 1.获取控件IP值 int GetAddress(byte& byteFirst, byte& byteTwo, byte& ...

  9. Oracle错误问题---- 《ora-12638:身份证明检索失败》

    使用客户端可以连接,但只有一个站点出现此问题,非常郁闷,网上查了一下,发现是用户认证问题,解决办法如下: 在ORACLE客户端目录下 NETWORK/ADMIN下的sqlnet.ora,使用记事本打开 ...

  10. CURL请求接口

    private function  http_curl($url,$data=null){ //1.初始化,创建一个新cURL资源                 $ch = curl_init(); ...